% Exercise 6

% Given x(n) = [3, 11, 7, 0, -1, 4, 2] , n in [-3, 3]
% Given h(n) = [2, 3, 0, -5, 2, 1], n in [-1, 4]
% Compute y(n) as x(n) convolved with h(n), n in  [-7, 7]. 

close all
clearvars
clc

%% signals

n_x = -3:3;
n_h = -1:4;
n = -7:7;

% Define both signals for n = -7:7
% put zeros where signals are not defined
x = [0, 0, 0, 0, 3, 11, 7, 0, -1, 4, 2, 0, 0, 0, 0];
h = [0, 0, 0, 0, 0, 0, 2, 3, 0, -5, 2, 1, 0, 0, 0];

%% convolution

% fold h --> h(k) --> h(-k) (with respect to 0)

% For details, see: https://it.mathworks.com/help/matlab/ref/fliplr.html
h_fold = fliplr(h); 

% initialize the final signal y
y = zeros(size(n));

% loop over all possible n-values
for n_aux = n
        
    % shift h_fold by n_aux

    h_shifted = circshift(h_fold, n_aux);
    
    if n_aux > 0
        h_shifted(1:n_aux) = 0;
    else
        h_shifted(end + n_aux :end) = 0;    
    end  

    % scalar product between x and h_shifted
    y(n == n_aux) = x*h_shifted';
    
end

figure;
stem(n, y)
title('y(n) without using conv');
grid;


%% use the matlab function 'conv'

% default:'full' convolution, with length = length(x) + length(h) - 1 
y1 = conv(x, h);

% support of the full convolution
supp_full = n(1) + n(1):n(end) + n(end);

figure;
stem(supp_full, y1);
title('y(n) using full conv');
grid;

%% which is the actual support of y1?

% if we define the signals without the zeroes (i.e., in their real supports)

x_reduced = [3, 11, 7, 0, -1, 4, 2];
h_reduced = [2, 3, 0, -5, 2, 1];

y_reduced = conv(x_reduced, h_reduced);
supp_true = n_x(1) + n_h(1):n_x(end) + n_h(end);

figure; 
stem(supp_true, y_reduced)
title('y(n) inside the true support');
grid;
